```julia
function house()
    trace1 = scatter()
    x0 = [2,   2,   5.5, 9,   9, 2,   5, 5, 6]
    y0 = [1,   5.5, 9.5, 5.5, 1, 5.5, 1, 4, 4]
    x1 = [2,   5.5, 9,   9,   2, 9,   5, 6, 6]
    y1 = [5.5, 9.5, 5.5, 1,   1, 5.5, 4, 4, 1]
    shapes = line(x0, x1, y0, y1; xref="x", yref="y")
    plot([trace1],
         Layout(;shapes=shapes, xaxis_range=(1, 10), yaxis_range=(0, 10)))
end
house()
```


<div id="5456049a-46ff-4a8a-9aa6-ad50d28c7cac" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('5456049a-46ff-4a8a-9aa6-ad50d28c7cac', [{"type":"scatter"}],
               {"shapes":[{"x0":2.0,"type":"line","y0":1.0,"y1":5.5,"yref":"y","xref":"x","x1":2.0},{"x0":2.0,"type":"line","y0":5.5,"y1":9.5,"yref":"y","xref":"x","x1":5.5},{"x0":5.5,"type":"line","y0":9.5,"y1":5.5,"yref":"y","xref":"x","x1":9.0},{"x0":9.0,"type":"line","y0":5.5,"y1":1.0,"yref":"y","xref":"x","x1":9.0},{"x0":9.0,"type":"line","y0":1.0,"y1":1.0,"yref":"y","xref":"x","x1":2.0},{"x0":2.0,"type":"line","y0":5.5,"y1":5.5,"yref":"y","xref":"x","x1":9.0},{"x0":5.0,"type":"line","y0":1.0,"y1":4.0,"yref":"y","xref":"x","x1":5.0},{"x0":5.0,"type":"line","y0":4.0,"y1":4.0,"yref":"y","xref":"x","x1":6.0},{"x0":6.0,"type":"line","y0":4.0,"y1":1.0,"yref":"y","xref":"x","x1":6.0}],"xaxis":{"range":[1,10]},"margin":{"l":50,"b":60,"r":50,"t":60},"yaxis":{"range":[0,10]}}, {showLink: false});

 </script>



```julia
function house2()
    trace1 = scatter()
    _p = string("M 2 1 L 2 5.5 L 5.5 9.6 L 9 5.5 L 9 1 L 2 1 ",
                "M 2 5.5 L 9 5.5 ",
                "M 5 1 L 5 4 L 6 4 L 6 1 Z")
    plot([trace1],
         Layout(;shapes=[path(_p)], xaxis_range=(1, 10), yaxis_range=(0, 10)))
end
house2()
```


<div id="ba9dce5e-0477-4e9b-a09f-09c14dfe506c" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('ba9dce5e-0477-4e9b-a09f-09c14dfe506c', [{"type":"scatter"}],
               {"shapes":[{"type":"path","path":"M 2 1 L 2 5.5 L 5.5 9.6 L 9 5.5 L 9 1 L 2 1 M 2 5.5 L 9 5.5 M 5 1 L 5 4 L 6 4 L 6 1 Z"}],"xaxis":{"range":[1,10]},"margin":{"l":50,"b":60,"r":50,"t":60},"yaxis":{"range":[0,10]}}, {showLink: false});

 </script>



```julia
function clusters()
    @eval using Distributions
    x0 = rand(Normal(2, 0.45), 300)
    y0 = rand(Normal(2, 0.45), 300)
    x1 = rand(Normal(6, 0.4), 200)
    y1 = rand(Normal(6, 0.4), 200)
    x2 = rand(Normal(4, 0.3), 200)
    y2 = rand(Normal(4, 0.3), 200)

    data = [scatter(;x=x0, y=y0, mode="markers"),
              scatter(;x=x1, y=y1, mode="markers"),
              scatter(;x=x2, y=y2, mode="markers"),
              scatter(;x=x1, y=y0, mode="markers")]

    args = [(x0, y0, "blue"), (x1, y1, "orange"), (x2, y2, "green"),
            (x1, y0, "red")]
    shapes = [circle(x0=minimum(x), y0=minimum(y),
                     x1=maximum(x), y1=maximum(y);
                     opacity=0.2, fillcolor=c, line_color=c)
              for (x, y, c) in args]
    plot(data, Layout(;height=400, width=480, showlegend=false, shapes=shapes))
end
clusters()
```


<div id="8716615b-a683-436a-b478-a16f2f6e29f7" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('8716615b-a683-436a-b478-a16f2f6e29f7', [{"mode":"markers","y":[2.2196589475081034,2.416997468516427,1.804156222605484,2.5781356466827146,1.449222387780392,1.4838964621451374,2.269763449819764,1.582682250079848,2.263044365272987,1.334526944177687,1.8877490414313842,1.7252184498991006,1.6169832298152915,2.1005354087201114,2.854968377681509,1.8085210947403387,2.4466619766697177,1.8533433837122588,1.6740973933843777,0.6602839144796364,1.730343446682522,1.9036621173928814,2.0553637098030366,1.3857103989322364,1.9640861476910114,1.6727639191657038,2.9161207756862932,1.500144334562552,2.8262039214621995,2.2739613262953036,1.4376806871639574,1.6699917118027752,1.3485194052175467,1.9924631791525702,2.1276508842189132,2.877498961232922,1.954348367838561,2.2588541776846687,2.4789217725443295,1.354235179314938,3.0441103151003244,1.0599101712782244,1.7755692923591075,2.038590426029947,2.2260755527783744,1.2221115686012292,2.4405245349613334,3.004492268062875,2.3037875839669857,2.255260875386957,2.4001658752016013,1.7146644627828889,1.9280440116004989,1.3084018896871554,1.8244591795175835,2.5601284873996852,2.05082259725693,1.6637330988174872,1.8197775395892526,1.8506350649339123,2.178562103173903,2.0323641634575242,1.4694595179691077,1.8515207446909587,1.6203600675100285,2.4132353992539675,2.0625712827431206,1.6521819930184878,1.6322421540129604,2.4045214307773337,1.7956997418439022,2.869138634068788,2.055187451870938,2.4167115827262204,2.1726841314449685,2.5270846409995578,1.9276220582839971,1.502066799496664,2.01485267722146,2.1975207593732877,1.715595600775031,2.0766518524336854,1.6215060377503747,1.9263397812153205,2.673643013142693,1.995134941630507,1.8225565709321585,2.4439959711647714,1.4876488950466435,2.2960386177807046,2.5255284128084012,1.621525362983176,2.3564400607739637,1.4211530841203537,1.6344983138888534,1.3044697149670457,1.8182740619140008,1.7407219201205686,1.8114765546809872,1.9441711604760303,2.150284342593205,2.5538121868533814,2.576058070805876,1.6541188357099046,2.2114151793374255,1.6473713454960532,1.9571703954727067,2.0969898924259502,2.113802718586487,1.711668101965543,1.889894173256244,2.482439800229897,1.4478801170956457,3.038910919306931,1.412595433577303,2.372257623970138,2.021550553135345,2.553431395438893,2.6485118165628387,2.078845153980242,1.7941796542591524,1.7195449393297124,2.0223272345197687,1.9355924962397657,2.5295005439947573,1.3134392705395483,0.8350244683902837,2.7487608337621006,1.8007089093222313,1.6243525369451977,2.1378443966052263,1.813611550445352,1.8401221308506093,2.438133412322432,1.2505014035835988,2.525731564531371,2.2557499249856665,2.817786768442687,2.2445576190549796,2.2170835566206635,1.942059184922521,1.6009142973243793,2.073513532075984,2.2341890296258677,1.8528620652166359,2.0877054677338247,2.1352924559864315,2.079984862243226,2.4815335860839207,2.3746418028274427,2.2881045673617546,2.162476099567961,1.607825831994741,2.212524677188032,2.1626647630455875,1.454974346271208,2.3973779665272086,1.0948963183960083,1.3340687942477472,2.2081507349988008,1.9619992211030282,1.6815265358919675,1.441612837045731,2.7321905910440716,2.17013409466534,1.6735264686474913,2.0499801321074673,2.0382128906833286,2.014983631947497,1.1006650189459894,1.4516605647064897,0.9058560698695948,2.0672489805058722,1.764009077469042,2.4148867021711156,0.6920448565403319,2.3777489067530624,1.8373306413774864,1.5123602903779274,1.2988096102836135,2.2724623273460574,2.1236655568495504,2.508263888958758,1.1857503166316796,2.545693558902604,2.3033743594812868,2.4612867063091266,1.7295789505026877,2.051788678741027,1.6791872127145462,2.1047766906655823,1.0117629820753933,1.710147549176417,2.0616482345126856,2.564097611436678,1.0173350864866912,1.7213210172783666,2.1958574838670963,2.8506289576329387,1.6404788349510924,2.5368361708250937,2.5415581563756335,2.1214334987589853,1.509396837627231,2.985893010241908,2.727940832061489,2.0655101893298675,1.5391519000269165,1.8889678054892283,1.7467098601650342,2.0070052541255503,1.865785608432372,1.829586575747472,1.9700045021456256,2.30261932314569,1.3937000459566673,0.983015822376379,1.8961233152598125,2.3734662390300123,1.852868095957149,2.228280898664535,2.013483936728401,0.8183930833006388,2.099529754192981,1.8233737028517334,1.8283534228422265,1.6562407346818266,1.5634535221821055,2.4771059687566117,2.00369821674179,2.212763669140168,1.4875673768172293,1.9923666146533072,2.312018692173327,1.634011829964991,1.5147732931411817,1.4482042937896065,1.887726469431689,2.0421128045085943,1.405392083280694,2.2608328244026334,1.5751531645650658,2.2867151777137815,2.2037596486401565,1.1719242595134047,1.7040779201712917,2.0178390890133837,2.293596372176916,2.695139164698297,2.6420203844705186,1.0186209344483634,2.3849724602388847,2.0202138760470487,1.970126898515037,2.1587876685420797,2.231914730821878,1.264272382527091,1.998889870634877,0.5957847493982009,1.930418656293319,1.9379040635414726,1.441953523667609,2.463287020485726,1.5866376888554024,2.7755182054454446,1.5800486578650417,1.824774048144394,2.123354083175667,2.1844158175436825,1.545302441877933,1.7259424225839899,2.5361984538236384,2.3302973683693873,2.025460368523261,1.349187441383516,1.2869905061254503,2.4656815479339502,1.9068631493434705,2.5236189337355515,1.7140827429576087,2.0214703179855467,2.3190522125199484,1.876896321856712,2.338639860611339,2.6355810481866664,2.7746780088185456,1.417666148960747,1.7926264375427308,1.8919290054533975,1.6819678256769115,2.3518234020797157,1.846084656099861,2.1348207459789075,2.1295315259023697,2.2604364935427768,2.4468837101832253,1.9249536340203666,1.1952383440038918,2.199191963498461,2.234634054160312],"type":"scatter","x":[1.8949878909402376,2.0680259219942605,1.9760508108378925,1.1924157725689573,1.5794853953979135,1.0595043568287021,1.636037054570533,1.5794427087444856,2.0556989915943094,1.0436035595430688,2.3251298328869816,2.302265208294664,2.0660227155417727,2.61281582908017,2.2391482332117048,1.9200921284572625,2.0370524252847937,2.255476720688201,2.6331338335100507,2.2198825753043976,1.1989415540723927,3.015128572673654,1.800798977013357,2.522867125247269,2.04880605362575,1.9093702939324957,1.4091004230449693,1.902068908914117,1.704008056496927,1.5954245899168704,2.130998119893793,2.3139925177149636,2.522824285111864,1.9134433047298622,1.7221956581719668,1.538030710612111,1.3030648769699504,1.587722197993229,1.2499121594115823,2.022731515963121,1.9217632821951518,2.1980708853484843,2.7765485387993465,1.574131069301329,2.748919965897289,2.999383796993418,1.4922956282607138,1.8874617291632827,2.1415766491280657,2.1989336933597174,2.4181711740639247,2.4222581217206107,0.9445555699043349,2.896638242464313,2.508705281644539,1.7893118957509833,0.6482081288182462,2.2130829396743823,1.2537576251657465,1.4294286336106892,2.3400964715027808,1.298313060070023,2.6399331687920315,1.846360688293136,2.562419530210865,2.1422063538150926,1.8878418037851017,1.4481963773670992,1.0199312041977526,1.5668738315462725,1.7162919698922476,2.3836729106463426,2.1902888239074216,1.4347705133358368,2.3953819868176907,2.7280932344064244,1.3888845422018714,2.609425803660771,2.272591523453606,1.3674401439235426,1.859007861247488,1.8526697614071612,2.300910159200087,2.1655587058850747,2.222582991910319,2.57368023237697,1.0960858870834562,2.343735655760585,1.7512299830626743,1.5602594720925276,1.7547439946567314,1.8919942051791199,1.9666837612086132,1.8588480454722975,2.3062545883677767,2.216675704537945,1.1696673724213218,2.130344480447465,2.03034676098218,1.5767113490849847,2.5023315026830986,2.531937390838749,2.0551810927326533,1.9548388769535268,1.9029605704095882,1.9790335256223566,2.5523981867190875,2.066392704069124,1.4847339608071157,2.5177164080659633,1.967571384308744,1.7463682962161937,1.782638057152068,2.2535982126499023,1.3096048101463524,1.6433351001575902,2.510488614738584,2.603290814036217,2.358606089054936,2.2121833240813555,2.458057475325235,1.5668478308077933,2.4202603103452436,1.9865328110842295,2.1141194168436246,1.6886283414936518,1.8500436004998992,2.0143563595227385,1.2519718980834533,2.1285222434822764,2.3670140459566715,1.7669129536080943,2.4102807201551837,1.979050543392727,1.1525053124730753,1.7715154176977066,2.220308393277084,2.2927520822294225,2.579530282065199,1.6110429807268039,2.6264389664293497,2.3425827687241263,2.2576008426412866,2.0112377501738017,2.482481025407907,2.173021599010338,2.3682624433684683,1.2829669321783477,2.485877620774432,1.9756483487716707,2.017569358617743,1.8573848984673613,2.2173621193353013,1.894858639852281,2.3210787928854026,2.615239448441873,2.745617504825079,1.688559379900659,1.9926442934085824,1.8047213955262684,2.2094258649623972,1.949390318394843,2.7897489819325303,2.0375942718466,2.853493413693456,2.527743866393502,2.4840409732855826,1.9255387413845801,1.5152187872852345,1.7237668273564761,2.2215049228098764,2.3769371308325407,1.8120395929519892,1.7935547794121867,2.138956390302738,1.3284576206341057,2.6457710159954457,1.7959768916427825,2.1885918785360197,1.6639322953148246,1.7978807826547683,2.355467708224177,1.4287307326498384,1.1490865264168568,1.9185250819083266,2.4540597625577174,1.6818041584105334,2.4053878831194924,2.7534729767307877,1.9067173607118213,1.9746505264520566,2.0799242425616513,1.5610578041621532,1.5476418009553585,1.9185559967944958,1.9168273011529935,1.210283011776403,1.704361578838644,1.6743952951271883,1.8834766148067361,1.9951858254457502,0.9665934376728249,2.1504288765965827,2.0186737319741956,1.1713382590379091,2.0809923524588942,2.4569149111847945,2.8718197460656105,2.033368704665382,2.2606398827774137,2.766204164291212,2.1867780302484547,2.0580026614806424,1.534776338735114,1.660631109878064,2.307938297583178,2.177619765216017,1.63042098960288,2.4962916650404714,1.548946397942217,2.5609911620346484,1.654250766142863,2.2635444949933063,2.5568393712266912,1.531840186030852,2.5349860274951954,3.1401868696652713,2.0251894581056242,2.953172177052897,2.245752479518984,2.195172316551538,1.2648361532928374,2.431478132209703,1.697103798447758,2.1364212272586154,1.4189562926458281,1.3674564247819065,2.081704279337717,2.5733453764029046,2.71514974122865,1.7482082104916183,1.8696312455065696,2.551341065894622,2.1572789012381484,2.255484386526433,1.8610904888450928,2.762903197188067,1.6794770352328756,2.31078290429577,1.657268573948922,2.2778166209176374,2.7583566143689793,1.9451309533359553,1.262498209067036,2.16845318876517,2.217059497800022,2.271124963378654,2.240948259615627,1.763843330783343,1.9165549594129958,1.6676839108874677,0.9369462123917762,1.8600420202525056,1.9463769613503479,1.7706503389515467,2.4397496364259545,1.853101825345124,2.4678698412694935,1.388769203515922,1.8179487732981248,2.0309006793299376,1.9925089306931438,2.436413357911256,2.059760442552375,1.7409384305022124,2.1745696356581603,1.7293091548370663,1.9040142359343961,1.4976391157216735,1.7523571114688132,1.8190430200035848,2.811722718895492,1.6411540162808143,2.8936424787371133,2.066535753885528,2.3412169299218597,1.5515144077199257,2.818693100087574,1.8008242698961006,2.554225618520714,1.3697428684581912,2.1047792363649696,1.9094070247569528,2.064062241094188,1.6727105351042844,2.3126271159409932,2.1825034853033802,1.8198607363320278,2.411383554845809,2.4213347779016074]},{"mode":"markers","y":[6.618361035957433,6.306019138269868,6.2539731155122915,6.008501806618142,5.917637294899335,6.256019684881725,6.379957307283241,5.595916255661071,5.9437485152669405,6.1451646349100635,6.45875130198474,6.021187809749011,6.231736413485849,6.084013865767278,6.0695602591488615,5.554266561627236,5.343828569120299,5.839798673833219,6.155817791032,5.86610791001482,6.329877142583327,6.230481727679833,5.976443694612941,5.870720154757992,5.78304798933207,6.515697548065519,5.638205338652284,6.423191787431463,6.268064366697033,6.151582883127035,5.526900136596852,6.039742793913216,5.7920355663384,5.9439084716424295,5.987356714779017,5.958731287159895,5.992268479977871,5.581230918745973,6.307146787072693,5.859326349364998,5.610049276722205,5.920994906626275,5.66457883924871,5.984978374179719,6.033988658531108,5.937922546162997,6.024073382835964,6.577709859339479,5.898760435293212,5.708256470253674,5.3311002186331615,5.668057876147852,6.770890018005447,5.837492459017611,6.176350659180025,6.669408198798324,5.6829955474269225,6.319660097363481,6.541849683017577,5.366210234838991,6.62055908625923,5.647386548331956,5.520703159614123,5.843518587149918,6.13242242381032,6.348023805868288,5.900396452721503,5.681214464013018,5.916255513767533,5.690168370038026,6.113884663201476,5.822904210653932,5.795666774350221,5.74471237531328,6.110108063508778,5.6221119228114995,5.472960549712621,6.178426434883507,5.730568400634515,6.4971934490349454,5.909348870811398,5.677873410218197,5.799405511620719,4.827367012307304,5.931458538289873,5.731184095273694,5.648594497813122,5.942189992243261,6.257223980092269,6.216271315477437,5.408918403233352,5.808313433939747,5.586660614765591,5.108547292968394,6.182251455923777,5.7435673684135145,6.577681925298048,5.977695442422636,5.870047795296447,5.792584993466604,6.514105433054669,6.003193692770621,6.71343723748469,6.433917531832566,6.4017234132516725,5.524348166666917,5.814099134500403,5.886589461030023,6.31716616564521,5.650473848435006,6.191451131402923,5.523191592154422,6.203891654673764,6.3948942026518045,5.8001902993161885,5.634456302716309,6.2957577210482984,5.490116221832846,6.8921922202845884,6.524298134496642,6.144950312283719,6.467752094349172,6.077349962955768,5.951334121278927,5.614479228263241,6.07337686479256,6.108585974964518,6.07414091411182,5.667781772560053,6.12189724874291,5.225069413664512,6.283203691105788,6.403828834224453,5.926802533317641,6.348941785925086,6.167273530413714,6.6024459639394335,6.349068257386207,6.02117840361469,5.674018797663785,5.742996570014528,5.9518122746726965,6.54018644654015,6.155365703973438,6.544467050826393,6.321071727035598,6.055539485320611,6.717654148985929,5.759308818719071,5.963451937275917,5.740195264572886,6.113226017992433,6.051576387035833,6.02064419321607,5.4641960473046804,4.900769599359441,6.012239579403914,5.975301023298562,5.643877736804009,5.9836503685534375,6.534228533368359,5.7090443081028575,5.496749546817908,5.997060540454845,5.6193453464267025,5.451825024457685,5.97826149156325,6.196101465982009,5.907552883274886,6.062568019577939,5.700474714414804,5.500123010798635,5.506362030983182,5.828183960636891,5.603223106057568,5.639991234228203,5.725607953762818,6.1998134602291115,5.796589217620629,5.87848968641153,5.613431756808154,5.895479495297605,6.088406970646771,6.370344563875615,5.930561730332683,6.9009025790654075,5.75937523600029,6.432870115345952,6.135864988433858,5.901607669926302,5.764724651104768,6.543019841128219,5.61126687192133,6.295948773265941,6.179352874109975,6.489662406572343,6.4437029374526755,6.064848699303493,6.207228010037544,5.288834236799543],"type":"scatter","x":[5.7731406522578546,6.473442496361967,6.185157167603152,5.908126952613595,6.00378351945032,6.889554861038312,5.489692759924456,5.612646616925192,5.593540144379235,5.669179437918144,5.595791148839918,6.278684882945826,5.963959276335678,6.5822835094456265,5.869311559023362,5.923271816366638,6.180891867219803,5.406925978882504,6.3507656213597095,6.265927737854966,6.301740011873861,6.48965160766878,5.748367883542965,5.739059119135699,5.563762523337612,5.784709982700899,5.454052087204206,6.0080220812790515,5.503831661989686,5.947741141357315,5.73162068197486,5.882109404884292,6.571523570579595,6.071126609299786,6.15247835726611,5.835219917516973,5.641004647900745,5.7093580748886685,6.073807771839207,6.3648082207889285,5.7124770086879035,5.535914724479125,6.241903790182217,6.490553890760449,6.280587981626787,6.726978409820791,6.644598447861699,6.612306624457805,5.792329043697203,6.261458721861326,5.997269965770275,6.239727506509795,5.677050202199979,5.931646719091089,6.775816258912327,5.506793361286446,6.594306748781307,6.540541363929972,6.391474105148016,5.730793123240527,5.5441404017902105,5.72349922119162,5.399562574639522,5.242349537774113,5.994476948668884,5.7621096916976144,6.690235955920853,5.56175019711599,5.61904934067057,6.14605061798355,6.509618711805668,5.792620941573373,5.635228109120138,6.054815954631299,6.262043586330605,6.244086789708664,5.813179847941371,5.6422926634528,6.631496794483453,6.115783493058979,6.032934018429087,5.900859298718604,5.658486132154729,5.934477822714965,5.103763258916767,5.827829195859934,6.001151841210498,6.2773212988939955,5.869608633007305,6.1843972894657,5.599924224330739,5.756438396262763,5.514392804944934,6.284374161419832,6.137161773853653,5.889702175686397,6.069321400171656,5.918879738698602,5.768561541899341,6.017110483423099,5.432138910510387,5.967908118686758,5.927325521582771,5.901663325516424,5.978132077444944,5.5810071752092645,6.199035778932171,5.660468161210439,5.729166398259656,6.156034098337229,5.761877608372965,5.99560832405165,6.214037353872255,6.560160654017818,6.8957103842144365,5.706073576494076,5.990166722366751,5.715382903806344,5.48074148382556,6.263060273825183,6.001890292058765,6.074916877487829,5.943762981159869,5.900610199600993,6.192371875737912,5.509501886598266,5.607663247985662,6.0643949617325195,6.415455631946976,5.866076628851618,7.195352464725307,5.6409960167843884,6.03507597098472,6.307994149092493,5.703400682535137,6.378115638211021,6.444188603431352,6.764280473717478,6.430246345674659,6.258279377638022,6.625995555541186,6.2619911387085745,5.4813219458010005,5.340453975181317,6.742591061138994,6.079828098691783,5.905400900074167,6.144134880594362,6.340039258972582,6.628632043614457,6.335904361436391,5.358282594101366,5.911994564017727,6.084643092651898,5.879172801957349,6.421597324649231,5.612600997297635,5.604732632581518,6.382735877808013,6.479512951395651,5.146556495493292,6.476164610239081,6.38079750273518,5.684940326951465,5.113196837371203,6.82695888518689,5.970586704488547,5.766552923555233,5.727363875017253,6.201847221097285,6.461711233135589,5.773222656494929,5.932905896544923,6.725331355081799,6.053891553096522,6.2696761541689385,5.95327536348413,5.931404649427783,5.820862784993445,6.246239895330157,5.983568202614236,6.069761707120174,6.293172391602972,5.719175528227708,6.273477443522444,6.149515459745277,5.439501689349045,6.602539261952885,5.621601184121218,5.665443607163305,6.489482711794271,5.677228271108821,5.967218860242655,5.49684570405529,5.5689385716761395,5.931885725839602,5.793176616437632,6.320259199249154,6.788927186698757,5.854587401021249]},{"mode":"markers","y":[4.16087978872776,3.864457997174005,3.9234626124392764,3.7838566678014782,3.9212255280400545,3.556365836518649,3.7309227203545667,3.7547304654930977,4.0288932853645,4.567711812826968,3.9109389824998493,4.059851202773684,3.631996064208075,3.8455780930287347,4.16338925318741,4.1445561352947236,3.5556030695083134,3.785493697605936,3.8370615186110926,4.635402890261244,3.8357592171500823,4.118209061240789,4.315078694754361,4.020818218790674,4.191649516500753,3.9848747237628905,3.7385439762755803,3.6930337938552644,3.387317034423045,4.494254654875393,4.056245540081421,4.506416175369128,4.0090319041730424,3.9288909384713135,4.463998618013434,3.8521798381031043,3.4860268001837382,4.092127714427075,3.818609395822005,4.699290812895024,3.955890300615175,3.9906914863618805,4.053357668747149,4.055487093175202,3.7316119129914496,4.322492823269352,4.698605947189204,4.405757983871526,4.338350763831491,4.5070796219138805,4.341782699541135,4.648112005282987,3.7361576694844305,4.292765946097688,3.6595694255552322,3.76500333155017,3.586953623572779,4.397504100898469,4.023068966957297,3.923155328911438,4.106068263562604,3.7872882361316567,3.8566480951643856,4.2237706432067466,4.060761784033646,3.3539429090226682,3.8809618992914308,3.6650511718920087,4.563529238478125,4.124458586031474,4.052371237460877,4.3842635716019975,4.28123666484643,4.108085988737123,3.7522910441362023,3.6072867245084774,3.9535207403442696,3.556379299916333,3.5005380708621017,3.727353703555164,4.260153528944182,3.6589844656607684,4.100611722047481,3.9853433271312335,3.8810171474631114,4.378832967938002,4.032255826295303,3.9202896578362902,4.194567830248382,4.200525659169564,4.252770612009802,4.013667565556105,4.406951715172178,3.6668168315580485,3.2788651809887615,4.068865996357742,3.9709732860777245,4.249964976697702,4.473722743350464,3.578689331131605,4.3265368698980815,4.163243089051778,4.035686155526156,3.6913263222969754,4.756883042171977,3.709143012398412,3.8127828762260645,3.3924535809780485,4.11781880564362,3.5611059858566465,4.087056272266586,3.868988889082081,4.429321014371725,3.373298829053745,4.097150234528085,3.5912535188033385,4.08586815779099,4.054980452869966,3.856496638246585,3.9395768002385343,4.707779093870228,4.179123963805522,4.163377495827714,3.9150186251426526,3.8692532407599813,4.35149379804883,4.19224541109393,3.89394503639364,4.013979536053816,4.080862570254283,3.6633904973468745,3.3955232801940802,3.8829542813507105,3.7618246812325347,4.389417304406289,4.096218064092347,3.8350695514789055,3.992588110007919,4.19696803518362,4.2420961987888886,4.189363176001202,4.0271071571547505,3.9854232976013044,3.9146244279132043,3.991061112178692,4.100461203128319,4.069553035825623,4.286453870909271,3.9525223723129717,4.033144577430513,4.003454274674307,3.864714204413697,3.196417037862408,4.009602299995624,4.111895329049058,3.7596092763486046,3.895169978560308,3.7764067626627087,3.7163482323180603,3.313073217187953,3.729285456314465,3.7548698125461315,4.048486471873176,4.414371900502863,3.969127492477477,4.30294735511512,4.128106207103168,3.6607458630641725,4.171566246352551,4.225394249017751,4.051914177238148,3.868269949399045,4.161744386193371,3.5746315742582335,3.2564193164937576,4.132215564991892,3.92679717826679,4.581836957557244,4.460868367066202,4.287502953598847,4.661545691099191,3.837411646161724,3.63427151747941,4.036604209140627,4.289763884985477,4.5829986629969826,4.51716877414327,3.9241564120117074,4.261940677080589,4.041293134781034,4.088332234218635,3.6874261690500565,4.24491668118522,3.9028929634365728,3.492915606635179,4.106885602373624,3.7402314864470854,3.7140034747798,4.062788096828666,3.6622610535051634],"type":"scatter","x":[4.917617892419607,4.189910628290254,3.717035515764983,4.170404333068596,3.6624377805107233,4.247062355615384,4.061946722254161,3.7717226696026356,4.292461922553273,4.016842523749653,3.550797500944497,4.128092213839671,3.4953082795149073,3.578253059557826,4.225675945874295,4.257673767877937,3.759608714130387,3.823559738705838,4.587865746036146,4.267043500382913,3.867485180610871,3.564673263762624,4.093021885621493,4.002531457132099,4.220634849264598,4.297259235529745,4.077753468532934,3.6611815103582477,3.9246878078835343,4.090332412305468,3.856666905395354,4.2216136290069555,4.312593657782289,3.9916627882906464,4.147655715367139,3.8449472611358035,4.1273189762359985,4.052395767489605,3.947149004857561,3.9594537488160784,3.8033814177235863,4.207962022610616,4.01649475999431,3.8895609768562,4.18727630142201,4.06299400522022,3.7051574467324553,3.5407313236152667,3.6423370504900525,4.368200744271768,3.4609433704956927,3.6827462022639823,3.868254488520616,3.9202082228893147,3.2595997978987827,4.187171767080025,3.9005796119441394,3.95423941058329,3.591416349615996,4.113275738273606,4.036246005466661,4.242468336509942,4.596376422262022,3.6858111808895675,4.7858016310351825,4.008224582687062,3.5829517647211913,4.24894312018961,4.058956785376887,4.059943245684563,3.861588135036713,3.5611208994611045,4.440257758390715,3.5178803159596765,4.12659254894795,3.5807147301315654,4.1561425775345056,4.49164425877448,3.6809575287538374,3.9903798151574716,4.812663824845167,3.3841091609700578,3.9914780405104446,4.035488998905853,4.076875635756939,4.401779076273771,3.7293448055183607,4.583575336438158,4.151365632182692,4.350411479485122,4.004603086182826,4.365675407972834,3.8468201692162554,3.856188143126958,3.459852676458343,3.5660098944766463,4.116261365844222,4.4672353212855285,3.943847484336196,4.524314640464712,4.276171504013994,4.450449084098452,4.148413284266626,3.7079010913820647,3.814744911060014,4.916587641090491,3.9704760370650414,3.7885185276397757,3.965349682968878,3.237413950414507,3.887606945762231,3.8346733907010693,3.6613985226570804,3.9782926420779137,3.9913647930816794,3.765963128857661,4.192561563581135,4.461787766751505,4.1597512411065445,3.7067045661111075,3.9526902334286924,4.3678934469596244,4.09504338940371,3.8260413833796014,3.3004808134324364,4.044711581269848,3.662981266749098,4.368300480171361,3.961118311444809,3.9030650298355956,3.6272587702439805,4.137197045342878,3.996204419029732,3.7973054995127407,3.9140153493893823,3.942206399939278,3.8917661539070973,3.8387917307472987,4.323550879169493,3.730010596850909,3.751564394069234,3.954201393055519,3.856199734777727,4.206716073147114,3.8342405509387945,4.012489857009336,4.191542703545245,4.300650797092652,3.7497543142127965,3.7814307378563443,4.076438321214349,3.616201805465492,4.540972477087552,4.346484203286368,3.495001841578924,4.271686718210769,4.035429999913043,4.155801297477444,3.740803824250518,3.9194558064023024,4.302501008415009,4.500832600849652,3.50264358646141,4.107103572783146,3.563923786628083,4.08294141685782,3.8445597189574916,4.26031758341561,4.138153068524391,4.197768871111026,4.022174557093896,3.9891826641318318,4.317416005871259,4.263169688196365,3.769153688667393,3.618687475885569,3.8951950527123564,4.078347447488027,3.74294480321222,3.932468395604341,3.7611622910428637,4.679553731219179,3.9942262245130284,4.023465001479878,4.013658411772326,3.431180263991263,3.800679603639483,3.7143036658262676,3.715007173151699,4.050697431276345,3.524697016363906,3.5906456416294037,3.8989073833059713,4.3109553354641275,3.591071512305639,3.987510556153225,3.7871929549656347,3.929032053139606,4.011441397138024,4.031403484950967]},{"mode":"markers","y":[2.2196589475081034,2.416997468516427,1.804156222605484,2.5781356466827146,1.449222387780392,1.4838964621451374,2.269763449819764,1.582682250079848,2.263044365272987,1.334526944177687,1.8877490414313842,1.7252184498991006,1.6169832298152915,2.1005354087201114,2.854968377681509,1.8085210947403387,2.4466619766697177,1.8533433837122588,1.6740973933843777,0.6602839144796364,1.730343446682522,1.9036621173928814,2.0553637098030366,1.3857103989322364,1.9640861476910114,1.6727639191657038,2.9161207756862932,1.500144334562552,2.8262039214621995,2.2739613262953036,1.4376806871639574,1.6699917118027752,1.3485194052175467,1.9924631791525702,2.1276508842189132,2.877498961232922,1.954348367838561,2.2588541776846687,2.4789217725443295,1.354235179314938,3.0441103151003244,1.0599101712782244,1.7755692923591075,2.038590426029947,2.2260755527783744,1.2221115686012292,2.4405245349613334,3.004492268062875,2.3037875839669857,2.255260875386957,2.4001658752016013,1.7146644627828889,1.9280440116004989,1.3084018896871554,1.8244591795175835,2.5601284873996852,2.05082259725693,1.6637330988174872,1.8197775395892526,1.8506350649339123,2.178562103173903,2.0323641634575242,1.4694595179691077,1.8515207446909587,1.6203600675100285,2.4132353992539675,2.0625712827431206,1.6521819930184878,1.6322421540129604,2.4045214307773337,1.7956997418439022,2.869138634068788,2.055187451870938,2.4167115827262204,2.1726841314449685,2.5270846409995578,1.9276220582839971,1.502066799496664,2.01485267722146,2.1975207593732877,1.715595600775031,2.0766518524336854,1.6215060377503747,1.9263397812153205,2.673643013142693,1.995134941630507,1.8225565709321585,2.4439959711647714,1.4876488950466435,2.2960386177807046,2.5255284128084012,1.621525362983176,2.3564400607739637,1.4211530841203537,1.6344983138888534,1.3044697149670457,1.8182740619140008,1.7407219201205686,1.8114765546809872,1.9441711604760303,2.150284342593205,2.5538121868533814,2.576058070805876,1.6541188357099046,2.2114151793374255,1.6473713454960532,1.9571703954727067,2.0969898924259502,2.113802718586487,1.711668101965543,1.889894173256244,2.482439800229897,1.4478801170956457,3.038910919306931,1.412595433577303,2.372257623970138,2.021550553135345,2.553431395438893,2.6485118165628387,2.078845153980242,1.7941796542591524,1.7195449393297124,2.0223272345197687,1.9355924962397657,2.5295005439947573,1.3134392705395483,0.8350244683902837,2.7487608337621006,1.8007089093222313,1.6243525369451977,2.1378443966052263,1.813611550445352,1.8401221308506093,2.438133412322432,1.2505014035835988,2.525731564531371,2.2557499249856665,2.817786768442687,2.2445576190549796,2.2170835566206635,1.942059184922521,1.6009142973243793,2.073513532075984,2.2341890296258677,1.8528620652166359,2.0877054677338247,2.1352924559864315,2.079984862243226,2.4815335860839207,2.3746418028274427,2.2881045673617546,2.162476099567961,1.607825831994741,2.212524677188032,2.1626647630455875,1.454974346271208,2.3973779665272086,1.0948963183960083,1.3340687942477472,2.2081507349988008,1.9619992211030282,1.6815265358919675,1.441612837045731,2.7321905910440716,2.17013409466534,1.6735264686474913,2.0499801321074673,2.0382128906833286,2.014983631947497,1.1006650189459894,1.4516605647064897,0.9058560698695948,2.0672489805058722,1.764009077469042,2.4148867021711156,0.6920448565403319,2.3777489067530624,1.8373306413774864,1.5123602903779274,1.2988096102836135,2.2724623273460574,2.1236655568495504,2.508263888958758,1.1857503166316796,2.545693558902604,2.3033743594812868,2.4612867063091266,1.7295789505026877,2.051788678741027,1.6791872127145462,2.1047766906655823,1.0117629820753933,1.710147549176417,2.0616482345126856,2.564097611436678,1.0173350864866912,1.7213210172783666,2.1958574838670963,2.8506289576329387,1.6404788349510924,2.5368361708250937,2.5415581563756335,2.1214334987589853,1.509396837627231,2.985893010241908,2.727940832061489,2.0655101893298675,1.5391519000269165,1.8889678054892283,1.7467098601650342,2.0070052541255503,1.865785608432372,1.829586575747472,1.9700045021456256,2.30261932314569,1.3937000459566673,0.983015822376379,1.8961233152598125,2.3734662390300123,1.852868095957149,2.228280898664535,2.013483936728401,0.8183930833006388,2.099529754192981,1.8233737028517334,1.8283534228422265,1.6562407346818266,1.5634535221821055,2.4771059687566117,2.00369821674179,2.212763669140168,1.4875673768172293,1.9923666146533072,2.312018692173327,1.634011829964991,1.5147732931411817,1.4482042937896065,1.887726469431689,2.0421128045085943,1.405392083280694,2.2608328244026334,1.5751531645650658,2.2867151777137815,2.2037596486401565,1.1719242595134047,1.7040779201712917,2.0178390890133837,2.293596372176916,2.695139164698297,2.6420203844705186,1.0186209344483634,2.3849724602388847,2.0202138760470487,1.970126898515037,2.1587876685420797,2.231914730821878,1.264272382527091,1.998889870634877,0.5957847493982009,1.930418656293319,1.9379040635414726,1.441953523667609,2.463287020485726,1.5866376888554024,2.7755182054454446,1.5800486578650417,1.824774048144394,2.123354083175667,2.1844158175436825,1.545302441877933,1.7259424225839899,2.5361984538236384,2.3302973683693873,2.025460368523261,1.349187441383516,1.2869905061254503,2.4656815479339502,1.9068631493434705,2.5236189337355515,1.7140827429576087,2.0214703179855467,2.3190522125199484,1.876896321856712,2.338639860611339,2.6355810481866664,2.7746780088185456,1.417666148960747,1.7926264375427308,1.8919290054533975,1.6819678256769115,2.3518234020797157,1.846084656099861,2.1348207459789075,2.1295315259023697,2.2604364935427768,2.4468837101832253,1.9249536340203666,1.1952383440038918,2.199191963498461,2.234634054160312],"type":"scatter","x":[5.7731406522578546,6.473442496361967,6.185157167603152,5.908126952613595,6.00378351945032,6.889554861038312,5.489692759924456,5.612646616925192,5.593540144379235,5.669179437918144,5.595791148839918,6.278684882945826,5.963959276335678,6.5822835094456265,5.869311559023362,5.923271816366638,6.180891867219803,5.406925978882504,6.3507656213597095,6.265927737854966,6.301740011873861,6.48965160766878,5.748367883542965,5.739059119135699,5.563762523337612,5.784709982700899,5.454052087204206,6.0080220812790515,5.503831661989686,5.947741141357315,5.73162068197486,5.882109404884292,6.571523570579595,6.071126609299786,6.15247835726611,5.835219917516973,5.641004647900745,5.7093580748886685,6.073807771839207,6.3648082207889285,5.7124770086879035,5.535914724479125,6.241903790182217,6.490553890760449,6.280587981626787,6.726978409820791,6.644598447861699,6.612306624457805,5.792329043697203,6.261458721861326,5.997269965770275,6.239727506509795,5.677050202199979,5.931646719091089,6.775816258912327,5.506793361286446,6.594306748781307,6.540541363929972,6.391474105148016,5.730793123240527,5.5441404017902105,5.72349922119162,5.399562574639522,5.242349537774113,5.994476948668884,5.7621096916976144,6.690235955920853,5.56175019711599,5.61904934067057,6.14605061798355,6.509618711805668,5.792620941573373,5.635228109120138,6.054815954631299,6.262043586330605,6.244086789708664,5.813179847941371,5.6422926634528,6.631496794483453,6.115783493058979,6.032934018429087,5.900859298718604,5.658486132154729,5.934477822714965,5.103763258916767,5.827829195859934,6.001151841210498,6.2773212988939955,5.869608633007305,6.1843972894657,5.599924224330739,5.756438396262763,5.514392804944934,6.284374161419832,6.137161773853653,5.889702175686397,6.069321400171656,5.918879738698602,5.768561541899341,6.017110483423099,5.432138910510387,5.967908118686758,5.927325521582771,5.901663325516424,5.978132077444944,5.5810071752092645,6.199035778932171,5.660468161210439,5.729166398259656,6.156034098337229,5.761877608372965,5.99560832405165,6.214037353872255,6.560160654017818,6.8957103842144365,5.706073576494076,5.990166722366751,5.715382903806344,5.48074148382556,6.263060273825183,6.001890292058765,6.074916877487829,5.943762981159869,5.900610199600993,6.192371875737912,5.509501886598266,5.607663247985662,6.0643949617325195,6.415455631946976,5.866076628851618,7.195352464725307,5.6409960167843884,6.03507597098472,6.307994149092493,5.703400682535137,6.378115638211021,6.444188603431352,6.764280473717478,6.430246345674659,6.258279377638022,6.625995555541186,6.2619911387085745,5.4813219458010005,5.340453975181317,6.742591061138994,6.079828098691783,5.905400900074167,6.144134880594362,6.340039258972582,6.628632043614457,6.335904361436391,5.358282594101366,5.911994564017727,6.084643092651898,5.879172801957349,6.421597324649231,5.612600997297635,5.604732632581518,6.382735877808013,6.479512951395651,5.146556495493292,6.476164610239081,6.38079750273518,5.684940326951465,5.113196837371203,6.82695888518689,5.970586704488547,5.766552923555233,5.727363875017253,6.201847221097285,6.461711233135589,5.773222656494929,5.932905896544923,6.725331355081799,6.053891553096522,6.2696761541689385,5.95327536348413,5.931404649427783,5.820862784993445,6.246239895330157,5.983568202614236,6.069761707120174,6.293172391602972,5.719175528227708,6.273477443522444,6.149515459745277,5.439501689349045,6.602539261952885,5.621601184121218,5.665443607163305,6.489482711794271,5.677228271108821,5.967218860242655,5.49684570405529,5.5689385716761395,5.931885725839602,5.793176616437632,6.320259199249154,6.788927186698757,5.854587401021249]}],
               {"showlegend":false,"shapes":[{"x0":0.6482081288182462,"fillcolor":"blue","line":{"color":"blue"},"type":"circle","y0":0.5957847493982009,"y1":3.0441103151003244,"opacity":0.2,"x1":3.1401868696652713},{"x0":5.103763258916767,"fillcolor":"orange","line":{"color":"orange"},"type":"circle","y0":4.827367012307304,"y1":6.9009025790654075,"opacity":0.2,"x1":7.195352464725307},{"x0":3.237413950414507,"fillcolor":"green","line":{"color":"green"},"type":"circle","y0":3.196417037862408,"y1":4.756883042171977,"opacity":0.2,"x1":4.917617892419607},{"x0":5.103763258916767,"fillcolor":"red","line":{"color":"red"},"type":"circle","y0":0.5957847493982009,"y1":3.0441103151003244,"opacity":0.2,"x1":7.195352464725307}],"height":400,"margin":{"l":50,"b":60,"r":50,"t":60},"width":480}, {showLink: false});

 </script>



```julia
function temperature()
    x = ["2015-02-01", "2015-02-02", "2015-02-03", "2015-02-04", "2015-02-05",
         "2015-02-06", "2015-02-07", "2015-02-08", "2015-02-09", "2015-02-10",
         "2015-02-11", "2015-02-12", "2015-02-13", "2015-02-14", "2015-02-15",
         "2015-02-16", "2015-02-17", "2015-02-18", "2015-02-19", "2015-02-20",
         "2015-02-21", "2015-02-22", "2015-02-23", "2015-02-24", "2015-02-25",
         "2015-02-26", "2015-02-27", "2015-02-28"]
    y = rand(1:20, length(x))
    data = scatter(;x=x, y=y, name="temperature", mode="line")

    shapes = rect(["2015-02-04", "2015-02-20"], ["2015-02-06", "2015-02-22"],
                  0, 1; fillcolor="#d3d3d3", opacity=0.2, line_width=0,
                  xref="x", yref="paper")
    plot(data, Layout(shapes=shapes, width=500, height=500))
end
temperature()
```


<div id="2ebc6a51-db1b-4572-b6b9-c7489501bed0" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('2ebc6a51-db1b-4572-b6b9-c7489501bed0', [{"mode":"line","y":[3,7,5,18,10,17,3,9,16,1,12,11,6,10,6,2,20,4,20,5,4,15,3,15,12,8,18,18],"type":"scatter","name":"temperature","x":["2015-02-01","2015-02-02","2015-02-03","2015-02-04","2015-02-05","2015-02-06","2015-02-07","2015-02-08","2015-02-09","2015-02-10","2015-02-11","2015-02-12","2015-02-13","2015-02-14","2015-02-15","2015-02-16","2015-02-17","2015-02-18","2015-02-19","2015-02-20","2015-02-21","2015-02-22","2015-02-23","2015-02-24","2015-02-25","2015-02-26","2015-02-27","2015-02-28"]}],
               {"shapes":[{"x0":"2015-02-04","fillcolor":"#d3d3d3","line":{"width":0},"type":"rect","y0":0,"y1":1,"opacity":0.2,"yref":"paper","xref":"x","x1":"2015-02-06"},{"x0":"2015-02-20","fillcolor":"#d3d3d3","line":{"width":0},"type":"rect","y0":0,"y1":1,"opacity":0.2,"yref":"paper","xref":"x","x1":"2015-02-22"}],"height":500,"margin":{"l":50,"b":60,"r":50,"t":60},"width":500}, {showLink: false});

 </script>



```julia
function vlines1()
    # one scalar argument produces one line. Need to wrap in an array because
    # layout.shapes should be an array
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = [vline(2)]
    plot([trace1], Layout(;shapes=shapes))
end
vlines1()
```


<div id="b910bc5b-a266-43c5-bd31-bad853109fcd" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('b910bc5b-a266-43c5-bd31-bad853109fcd', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":2,"type":"line","y0":0,"y1":1,"yref":"paper","xref":"x","x1":2}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function vlines2()
    # one argument draws a vertical line up the entire plot
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = vline([2, 6])
    plot([trace1], Layout(;shapes=shapes))
end
vlines2()
```


<div id="a15dbd00-9865-4b04-9823-214bd2437bfc" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('a15dbd00-9865-4b04-9823-214bd2437bfc', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":2,"type":"line","y0":0,"y1":1,"yref":"paper","xref":"x","x1":2},{"x0":6,"type":"line","y0":0,"y1":1,"yref":"paper","xref":"x","x1":6}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function vlines3()
    # yref paper makes the 2nd and 3rd arguments on a (0, 1) scale vertically
    # so 0.5 is 1/2 through the plot regardless of the values on y-axis
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = vline([2, 6], 0, 0.5; yref="paper")
    plot([trace1], Layout(;shapes=shapes))
end
vlines3()
```


<div id="93fec97b-163d-4362-9033-f5931d6dc7bd" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('93fec97b-163d-4362-9033-f5931d6dc7bd', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":2,"type":"line","y0":0,"y1":0.5,"yref":"paper","x1":2},{"x0":6,"type":"line","y0":0,"y1":0.5,"yref":"paper","x1":6}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function vlines4()
    # Whichever argument is a scalar is repeated
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = vline([2, 6], 0, [0.5, 0.75]; yref="paper")
    plot([trace1], Layout(;shapes=shapes))
end
vlines4()
```


<div id="15e54b58-4803-44d6-8cc3-2f9f569a52ff" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('15e54b58-4803-44d6-8cc3-2f9f569a52ff', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":2,"type":"line","y0":0,"y1":0.5,"yref":"paper","x1":2},{"x0":6,"type":"line","y0":0,"y1":0.75,"yref":"paper","x1":6}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function vlines5()
    # we can also set arbitrary line attributes line color and dash
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = vline([2, 6], 0, [0.5, 0.75]; yref="paper",
                   line_color="green", line_dash="dashdot")
    plot([trace1], Layout(;shapes=shapes))
end
vlines5()
```


<div id="b8513e46-0f98-4c58-9d24-db1423c2fb3d" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('b8513e46-0f98-4c58-9d24-db1423c2fb3d', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":2,"line":{"color":"green","dash":"dashdot"},"type":"line","y0":0,"y1":0.5,"yref":"paper","x1":2},{"x0":6,"line":{"color":"green","dash":"dashdot"},"type":"line","y0":0,"y1":0.75,"yref":"paper","x1":6}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function hlines1()
    # one scalar argument produces one line. Need to wrap in an array because
    # layout.shapes should be an array
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = [hline(2)]
    plot([trace1], Layout(;shapes=shapes))
end
hlines1()
```


<div id="37a8a4f5-ca87-4b17-9560-9f16882af85a" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('37a8a4f5-ca87-4b17-9560-9f16882af85a', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":0,"type":"line","y0":2,"y1":2,"yref":"y","xref":"paper","x1":1}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function hlines2()
    # one argument draws a horizontal line across the entire plot
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = hline([25, 81])
    plot([trace1], Layout(;shapes=shapes))
end
hlines2()
```


<div id="2004e53a-3c25-4b58-8489-7743add2f792" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('2004e53a-3c25-4b58-8489-7743add2f792', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":0,"type":"line","y0":25,"y1":25,"yref":"y","xref":"paper","x1":1},{"x0":0,"type":"line","y0":81,"y1":81,"yref":"y","xref":"paper","x1":1}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function hlines3()
    # xref paper makes the 2nd and 3rd arguments on a (0, 1) scale horizontally
    # so 0.5 is 1/2 through the plot regardless of the values on x-axis
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = hline([25, 81], 0, 0.5; xref="paper")
    plot([trace1], Layout(;shapes=shapes))
end
hlines3()
```


<div id="f021c1a4-5bc7-46c4-b958-7b901ef2f59f" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('f021c1a4-5bc7-46c4-b958-7b901ef2f59f', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":0,"type":"line","y0":25,"y1":25,"xref":"paper","x1":0.5},{"x0":0,"type":"line","y0":81,"y1":81,"xref":"paper","x1":0.5}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function hlines4()
    # Whichever argument is a scalar is repeated
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = hline([25, 81], 0, [0.5, 0.75]; xref="paper")
    plot([trace1], Layout(;shapes=shapes))
end
hlines4()
```


<div id="588dfeed-18de-4bfa-ab3e-b6dee8effe8a" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('588dfeed-18de-4bfa-ab3e-b6dee8effe8a', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":0,"type":"line","y0":25,"y1":25,"xref":"paper","x1":0.5},{"x0":0,"type":"line","y0":81,"y1":81,"xref":"paper","x1":0.75}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function hlines5()
    # we can also set arbitrary line attributes line color and dash
    trace1 = scatter(;x=1:10, y=(1:10).^2)
    shapes = hline([25, 81], 0, [0.5, 0.75]; xref="paper",
                   line_color="green", line_dash="dashdot")
    plot([trace1], Layout(;shapes=shapes))
end
hlines5()
```


<div id="bec62964-2a6b-469f-8850-f5b809a97e46" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('bec62964-2a6b-469f-8850-f5b809a97e46', [{"y":[1,4,9,16,25,36,49,64,81,100],"type":"scatter","x":[1,2,3,4,5,6,7,8,9,10]}],
               {"shapes":[{"x0":0,"line":{"color":"green","dash":"dashdot"},"type":"line","y0":25,"y1":25,"xref":"paper","x1":0.5},{"x0":0,"line":{"color":"green","dash":"dashdot"},"type":"line","y0":81,"y1":81,"xref":"paper","x1":0.75}],"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



