```julia
function table1()
    values = [
        "Salaries" 1200000 1300000 1300000 1400000
        "Office" 20000 20000 20000 20000
        "Merchandise" 80000 70000 120000 90000
        "Legal" 2000 2000 2000 2000
        "TOTAL" 12120000 130902000 131222000 14102000
    ]

    trace = table(
        header=attr(
            values=["Expenses", "Q1", "Q2", "Q3", "Q4"],
            align="center", line=attr(width=1, color="black"),
            fill_color="grey", font=attr(family="Arial", size=12, color="white")
        ),
        cells=attr(
            values=values, align="center", line=attr(color="black", width=1),
            font=attr(family="Arial", size=11, color="black")
        )
    )
    plot(trace)

end
table1()
```


<div id="853fd841-54b8-4ae5-a9b2-823cc52bf943" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('853fd841-54b8-4ae5-a9b2-823cc52bf943', [{"type":"table","header":{"values":["Expenses","Q1","Q2","Q3","Q4"],"line":{"color":"black","width":1},"font":{"color":"white","family":"Arial","size":12},"fill":{"color":"grey"},"align":"center"},"cells":{"values":[["Salaries","Office","Merchandise","Legal","TOTAL"],[1200000,20000,80000,2000,12120000],[1300000,20000,70000,2000,130902000],[1300000,20000,120000,2000,131222000],[1400000,20000,90000,2000,14102000]],"line":{"color":"black","width":1},"font":{"color":"black","family":"Arial","size":11},"align":"center"}}],
               {"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function table2()
    values = [
        "Salaries" 1200000 1300000 1300000 1400000
        "Office" 20000 20000 20000 20000
        "Merchandise" 80000 70000 120000 90000
        "Legal" 2000 2000 2000 2000
        "TOTAL" 12120000 130902000 131222000 14102000
    ]

    trace = table(
        header=attr(
            values=["EXPENSES", "Q1", "Q2", "Q3", "Q4"],
            align=["left", "center"], line=attr(width=1, color="#506784"),
            fill_color="#119DFF",
            font=attr(family="Arial", size=12, color="white")
        ),
        cells=attr(
            values=values, align=["left", "center"],
            line=attr(color="#506784", width=1),
            font=attr(family="Arial", size=11, color="#506784"),
            fill_color=["#25FEFD", "white"]
        )
    )
    plot(trace)

end
table2()
```


<div id="50e5d1ab-32b0-4e96-bb13-74f1c558df37" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('50e5d1ab-32b0-4e96-bb13-74f1c558df37', [{"type":"table","header":{"values":["EXPENSES","Q1","Q2","Q3","Q4"],"line":{"color":"#506784","width":1},"font":{"color":"white","family":"Arial","size":12},"fill":{"color":"#119DFF"},"align":["left","center"]},"cells":{"values":[["Salaries","Office","Merchandise","Legal","TOTAL"],[1200000,20000,80000,2000,12120000],[1300000,20000,70000,2000,130902000],[1300000,20000,120000,2000,131222000],[1400000,20000,90000,2000,14102000]],"line":{"color":"#506784","width":1},"font":{"color":"#506784","family":"Arial","size":11},"fill":{"color":["#25FEFD","white"]},"align":["left","center"]}}],
               {"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function table2a()
    p1 = table1()
    restyle!(p1,
        header=attr(
            align=["left", "center"], line_color="#506784", fill_color="#119DFF"
        ),
        cells=attr(
            align=["left", "center"], line_color="#506784",
            fill_color=["#25FEFD", "white"], font_color="#506784"
        )
    )
    p1
end
table2a()
```


<div id="76e341c7-39f0-41bf-b2eb-9b6330c98dcc" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('76e341c7-39f0-41bf-b2eb-9b6330c98dcc', [{"type":"table","header":{"values":["Expenses","Q1","Q2","Q3","Q4"],"line":{"color":"#506784","width":1},"font":{"color":"white","family":"Arial","size":12},"fill":{"color":"#119DFF"},"align":["left","center"]},"cells":{"values":[["Salaries","Office","Merchandise","Legal","TOTAL"],[1200000,20000,80000,2000,12120000],[1300000,20000,70000,2000,130902000],[1300000,20000,120000,2000,131222000],[1400000,20000,90000,2000,14102000]],"line":{"color":"#506784","width":1},"font":{"color":"#506784","family":"Arial","size":11},"fill":{"color":["#25FEFD","white"]},"align":["left","center"]}}],
               {"margin":{"l":50,"b":60,"r":50,"t":60}}, {showLink: false});

 </script>



```julia
function table3()
    nm = tempname()
    url = "https://raw.githubusercontent.com/plotly/datasets/master/Mining-BTC-180.csv"
    download(url, nm)
    df = readtable(nm)
    rm(nm)

    data = Array(df)

    trace = table(
        columnwidth=[200, 500, 600, 600, 400, 400, 600, 600, 600],
        # columnorder=0:9,
        header=attr(
            values=map(x-> replace(string(x), '_', '-'), names(df)),
            align="center",
            line=attr(width=1, color="rgb(50, 50, 50)"),
            fill_color=["rgb(235, 100, 230)"],
            font=attr(family="Arial", size=12, color="white")
        ),
        cells=attr(
            values=Array(df),
            align=["center", "center"],
            line=attr(width=1, color="black"),
            fill_color=["rgba(228, 222, 249, 0.65)", "rgb(235, 193, 238)", "rgba(228, 222, 249, 0.65)"],
            font=attr(family="Arial", size=10, color="black")
        )
    )

    layout = Layout(
        title="Bitcoin mining stats for 180 days",
        width=1200
    )
    plot(trace, layout)
end
table3()
```


<div id="34028342-1fb5-4c6a-9c71-7565605172f8" class="plotly-graph-div"></div>

<script>
    window.PLOTLYENV=window.PLOTLYENV || {};
    window.PLOTLYENV.BASE_URL="https://plot.ly";
    Plotly.newPlot('34028342-1fb5-4c6a-9c71-7565605172f8', [{"type":"table","header":{"values":["x","Date","Number-transactions","Output-volume-BTC-","Market-price","Hash-rate","Cost-per-trans-USD","Mining-revenue-USD","Transaction-fees-BTC"],"line":{"color":"rgb(50, 50, 50)","width":1},"font":{"color":"white","family":"Arial","size":12},"fill":{"color":["rgb(235, 100, 230)"]},"align":"center"},"columnwidth":[200,500,600,600,400,400,600,600,600],"cells":{"values":[[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178],["2017-04-29 00:00:00","2017-04-30 00:00:00","2017-05-01 00:00:00","2017-05-02 00:00:00","2017-05-03 00:00:00","2017-05-04 00:00:00","2017-05-05 00:00:00","2017-05-06 00:00:00","2017-05-07 00:00:00","2017-05-08 00:00:00","2017-05-09 00:00:00","2017-05-10 00:00:00","2017-05-11 00:00:00","2017-05-12 00:00:00","2017-05-13 00:00:00","2017-05-14 00:00:00","2017-05-15 00:00:00","2017-05-16 00:00:00","2017-05-17 00:00:00","2017-05-18 00:00:00","2017-05-19 00:00:00","2017-05-20 00:00:00","2017-05-21 00:00:00","2017-05-22 00:00:00","2017-05-23 00:00:00","2017-05-24 00:00:00","2017-05-25 00:00:00","2017-05-26 00:00:00","2017-05-27 00:00:00","2017-05-28 00:00:00","2017-05-29 00:00:00","2017-05-30 00:00:00","2017-05-31 00:00:00","2017-06-01 00:00:00","2017-06-02 00:00:00","2017-06-03 00:00:00","2017-06-04 00:00:00","2017-06-05 00:00:00","2017-06-06 00:00:00","2017-06-07 00:00:00","2017-06-08 00:00:00","2017-06-09 00:00:00","2017-06-10 00:00:00","2017-06-11 00:00:00","2017-06-12 00:00:00","2017-06-13 00:00:00","2017-06-14 00:00:00","2017-06-15 00:00:00","2017-06-16 00:00:00","2017-06-17 00:00:00","2017-06-18 00:00:00","2017-06-19 00:00:00","2017-06-20 00:00:00","2017-06-21 00:00:00","2017-06-22 00:00:00","2017-06-23 00:00:00","2017-06-24 00:00:00","2017-06-25 00:00:00","2017-06-26 00:00:00","2017-06-27 00:00:00","2017-06-28 00:00:00","2017-06-29 00:00:00","2017-06-30 00:00:00","2017-07-01 00:00:00","2017-07-02 00:00:00","2017-07-03 00:00:00","2017-07-04 00:00:00","2017-07-05 00:00:00","2017-07-06 00:00:00","2017-07-07 00:00:00","2017-07-08 00:00:00","2017-07-09 00:00:00","2017-07-10 00:00:00","2017-07-11 00:00:00","2017-07-12 00:00:00","2017-07-13 00:00:00","2017-07-14 00:00:00","2017-07-15 00:00:00","2017-07-16 00:00:00","2017-07-17 00:00:00","2017-07-18 00:00:00","2017-07-19 00:00:00","2017-07-20 00:00:00","2017-07-21 00:00:00","2017-07-22 00:00:00","2017-07-23 00:00:00","2017-07-24 00:00:00","2017-07-25 00:00:00","2017-07-26 00:00:00","2017-07-27 00:00:00","2017-07-28 00:00:00","2017-07-29 00:00:00","2017-07-30 00:00:00","2017-07-31 00:00:00","2017-08-01 00:00:00","2017-08-02 00:00:00","2017-08-03 00:00:00","2017-08-04 00:00:00","2017-08-05 00:00:00","2017-08-06 00:00:00","2017-08-07 00:00:00","2017-08-08 00:00:00","2017-08-09 00:00:00","2017-08-10 00:00:00","2017-08-11 00:00:00","2017-08-12 00:00:00","2017-08-13 00:00:00","2017-08-14 00:00:00","2017-08-15 00:00:00","2017-08-16 00:00:00","2017-08-17 00:00:00","2017-08-18 00:00:00","2017-08-19 00:00:00","2017-08-20 00:00:00","2017-08-21 00:00:00","2017-08-22 00:00:00","2017-08-23 00:00:00","2017-08-24 00:00:00","2017-08-25 00:00:00","2017-08-26 00:00:00","2017-08-27 00:00:00","2017-08-28 00:00:00","2017-08-29 00:00:00","2017-08-30 00:00:00","2017-08-31 00:00:00","2017-09-01 00:00:00","2017-09-02 00:00:00","2017-09-03 00:00:00","2017-09-04 00:00:00","2017-09-05 00:00:00","2017-09-06 00:00:00","2017-09-07 00:00:00","2017-09-08 00:00:00","2017-09-09 00:00:00","2017-09-10 00:00:00","2017-09-11 00:00:00","2017-09-12 00:00:00","2017-09-13 00:00:00","2017-09-14 00:00:00","2017-09-15 00:00:00","2017-09-16 00:00:00","2017-09-17 00:00:00","2017-09-18 00:00:00","2017-09-19 00:00:00","2017-09-20 00:00:00","2017-09-21 00:00:00","2017-09-22 00:00:00","2017-09-23 00:00:00","2017-09-24 00:00:00","2017-09-25 00:00:00","2017-09-26 00:00:00","2017-09-27 00:00:00","2017-09-28 00:00:00","2017-09-29 00:00:00","2017-09-30 00:00:00","2017-10-01 00:00:00","2017-10-02 00:00:00","2017-10-03 00:00:00","2017-10-04 00:00:00","2017-10-05 00:00:00","2017-10-06 00:00:00","2017-10-07 00:00:00","2017-10-08 00:00:00","2017-10-09 00:00:00","2017-10-10 00:00:00","2017-10-11 00:00:00","2017-10-12 00:00:00","2017-10-13 00:00:00","2017-10-14 00:00:00","2017-10-15 00:00:00","2017-10-16 00:00:00","2017-10-17 00:00:00","2017-10-18 00:00:00","2017-10-19 00:00:00","2017-10-20 00:00:00","2017-10-21 00:00:00","2017-10-22 00:00:00","2017-10-23 00:00:00","2017-10-24 00:00:00"],[341319,281489,294786,333161,295149,354737,267193,363022,316011,365096,332879,311391,294743,317698,329266,369098,329229,233977,317527,288904,319502,352805,326057,327868,367710,338642,350114,333340,331914,308143,321638,347961,321634,319709,271539,305320,266044,289930,297416,339720,307377,282184,254993,222892,269098,291776,287644,293141,269937,236554,209359,269774,269438,280203,269685,259938,227127,180719,261906,259737,279811,231054,267360,221856,196539,253244,255483,237008,225106,243614,220835,188124,251722,265759,257138,245895,227903,221851,203165,230315,260575,253768,230199,268443,223358,181031,240072,244036,237853,225369,247207,211134,184145,231012,131875,209321,213017,235792,239771,199627,249002,275574,260955,257965,284001,260521,263310,255362,311002,274866,347319,312250,266832,210852,236772,196283,315734,203805,208169,226485,261891,223771,281116,271466,280724,283670,236811,195289,269280,277948,276225,256374,279488,217890,193240,253492,256230,263320,268068,292079,228257,197683,218204,282917,235723,255257,227615,203861,185277,226603,263648,257961,275976,254438,212678,203653,295002,282132,232826,273243,283699,231226,238385,296946,303101,292459,293164,309819,293140,283473,314725,334438,329579,356985,312409,312257,289131,316096,347220],[4488916,3918072,3892124,4099704,3425069,4359179,3347227,4359179,4333232,4670549,4021862,4119773,3757901,4286791,4398136,4565154,4732172,3674392,4314627,3952755,4565154,4592990,4091937,4064100,4976738,4562010,4828621,4532386,4976738,4887867,4473139,5302596,4858244,5035985,4325022,5687700,5432357,5533581,5094944,5567322,5567322,5094944,4757530,4926237,4959978,4757530,4723789,5162426,4993720,5129906,5129906,5342178,4882255,4953012,4917634,5660586,5165284,4316196,5023770,4634604,5554450,4245439,5448314,5802100,6622799,5988701,5389831,5248920,5002327,5213693,5812563,4861416,6939848,6094384,6235295,5530742,5559050,5079132,6518886,5918988,6598872,5958981,6478893,6158947,6398906,6878824,7118783,5918988,5878995,6585327,6414280,6713613,6285994,6200471,6371518,6499804,5901138,7654374,7568850,5986661,6542566,7012946,6333395,6149818,6608760,6195712,6792336,5966241,6975913,5966241,8215055,6838231,6930019,5966241,5277829,4084581,7297172,4459278,4459278,4635883,6843446,5695513,6578538,7417412,7196656,7682320,7240807,6799294,7726471,8697799,7430761,8072925,8027056,7751843,6329907,7981187,8623352,8715090,7981187,8256401,7751843,8072925,6965995,8556656,6417492,9653663,7624200,9105159,7953302,6856295,7569349,8063003,9708513,9269710,7569349,7130547,8380132,10223761,7486251,6983443,8882940,8827072,10167894,8994675,8938808,7765589,8547735,7597986,7877324,11601113,10351762,9756834,8983426,10589734,10649227,9102412,10827706,10173284,9935312],[3119179,2720216,2878278,3149553,2760373,3500746,2779170,3610789,3505620,4062173,3715394,3665041,3468077,3731718,3885821,4018028,4090703,3356332,4241264,3986175,4746880,4862317,4331490,4499105,5668946,5524488,5871334,5119620,5121737,5262057,5260814,6132064,5808558,6245229,5437775,7190853,5967105,6586584,6705146,7060708,6905690,6408509,5916953,6255384,5779114,5967684,5217093,5540766,5304594,5461151,5066180,5761788,5639440,5729388,5791396,6125532,5333680,4323782,5067818,4893545,5859694,4529058,5463199,5415823,6165437,5975339,5536125,5284211,5092047,5027244,5589288,4618491,6117733,5418690,5595773,4943868,4133223,3915180,4114452,4307538,5135591,4503487,6303560,5613835,5890365,5998935,6381473,4978580,4829128,5348203,5563273,5536230,5226926,5550845,5102353,5295684,5009853,6553817,7255240,5802572,6700312,7395324,6117049,6163928,7130611,7067967,8147957,7782196,9146734,8320553,10849951,8775120,8768358,7392849,6787387,5749752,10230715,6929316,7153228,7319122,9642616,8451776,10384095,11046351,11260487,12131998,10374578,9700710,10527922,11928774,10290919,11050159,10028960,9554034,7845878,9592187,10193192,9617967,7489085,8227898,8161423,8368700,6960685,8091884,6147322,8287404,6520223,7983282,6815446,6522957,7065925,8033184,9528010,9047637,7690943,7369622,8729899,10134350,7436308,7204664,8954116,8787393,10645076,9983564,10009312,8773874,10754101,10610179,11022592,14217107,13050105,12204887,11106218,13368297,13875337,12037733,14108349,13224118,12165126],[4488916,3918072,3892124,4099704,3425069,4359179,3347227,4359179,4333232,4670549,4021862,4119773,3757901,4286791,4398136,4565154,4732172,3674392,4314627,3952755,4565154,4592990,4091937,4064100,4976738,4562010,4828621,4532386,4976738,4887867,4473139,5302596,4858244,5035985,4325022,5687700,5432357,5533581,5094944,5567322,5567322,5094944,4757530,4926237,4959978,4757530,4723789,5162426,4993720,5129906,5129906,5342178,4882255,4953012,4917634,5660586,5165284,4316196,5023770,4634604,5554450,4245439,5448314,5802100,6622799,5988701,5389831,5248920,5002327,5213693,5812563,4861416,6939848,6094384,6235295,5530742,5559050,5079132,6518886,5918988,6598872,5958981,6478893,6158947,6398906,6878824,7118783,5918988,5878995,6585327,6414280,6713613,6285994,6200471,6371518,6499804,5901138,7654374,7568850,5986661,6542566,7012946,6333395,6149818,6608760,6195712,6792336,5966241,6975913,5966241,8215055,6838231,6930019,5966241,5277829,4084581,7297172,4459278,4459278,4635883,6843446,5695513,6578538,7417412,7196656,7682320,7240807,6799294,7726471,8697799,7430761,8072925,8027056,7751843,6329907,7981187,8623352,8715090,7981187,8256401,7751843,8072925,6965995,8556656,6417492,9653663,7624200,9105159,7953302,6856295,7569349,8063003,9708513,9269710,7569349,7130547,8380132,10223761,7486251,6983443,8882940,8827072,10167894,8994675,8938808,7765589,8547735,7597986,7877324,11601113,10351762,9756834,8983426,10589734,10649227,9102412,10827706,10173284,9935312],[9,10,10,10,10,10,11,10,11,12,12,12,12,12,12,11,13,15,14,14,15,14,14,14,16,17,17,16,16,18,17,18,19,20,21,24,23,24,23,21,23,23,24,29,22,21,19,20,20,24,25,22,22,21,22,24,24,25,20,19,22,20,21,25,32,24,22,23,23,21,26,25,25,21,23,21,19,18,21,19,20,18,28,22,27,34,27,21,21,25,23,27,29,25,40,26,24,29,31,30,28,28,24,25,26,28,32,31,31,31,32,29,34,36,30,30,33,35,35,33,38,39,38,42,41,44,45,52,41,44,39,45,37,45,42,39,41,38,29,29,37,44,33,30,27,33,30,40,38,30,28,32,36,37,37,37,31,37,33,27,33,39,46,35,34,31,38,36,39,52,43,38,35,39,46,40,50,43,36],[3119179,2720216,2878278,3149553,2760373,3500746,2779170,3610789,3505620,4062173,3715394,3665041,3468077,3731718,3885821,4018028,4090703,3356332,4241264,3986175,4746880,4862317,4331490,4499105,5668946,5524488,5871334,5119620,5121737,5262057,5260814,6132064,5808558,6245229,5437775,7190853,5967105,6586584,6705146,7060708,6905690,6408509,5916953,6255384,5779114,5967684,5217093,5540766,5304594,5461151,5066180,5761788,5639440,5729388,5791396,6125532,5333680,4323782,5067818,4893545,5859694,4529058,5463199,5415823,6165437,5975339,5536125,5284211,5092047,5027244,5589288,4618491,6117733,5418690,5595773,4943868,4133223,3915180,4114452,4307538,5135591,4503487,6303560,5613835,5890365,5998935,6381473,4978580,4829128,5348203,5563273,5536230,5226926,5550845,5102353,5295684,5009853,6553817,7255240,5802572,6700312,7395324,6117049,6163928,7130611,7067967,8147957,7782196,9146734,8320553,10849951,8775120,8768358,7392849,6787387,5749752,10230715,6929316,7153228,7319122,9642616,8451776,10384095,11046351,11260487,12131998,10374578,9700710,10527922,11928774,10290919,11050159,10028960,9554034,7845878,9592187,10193192,9617967,7489085,8227898,8161423,8368700,6960685,8091884,6147322,8287404,6520223,7983282,6815446,6522957,7065925,8033184,9528010,9047637,7690943,7369622,8729899,10134350,7436308,7204664,8954116,8787393,10645076,9983564,10009312,8773874,10754101,10610179,11022592,14217107,13050105,12204887,11106218,13368297,13875337,12037733,14108349,13224118,12165126],[256,199,228,273,247,307,261,297,277,316,303,303,280,322,301,297,327,343,486,392,443,388,353,407,468,473,499,470,529,421,495,588,570,569,470,546,442,475,511,668,491,456,391,356,410,479,455,435,375,311,278,387,388,463,447,339,307,259,375,368,386,341,357,255,198,283,294,226,242,241,192,157,206,208,222,211,215,378,167,198,225,202,229,250,171,125,167,168,168,166,188,156,138,195,76,131,124,113,114,88,122,159,158,193,235,211,190,249,350,348,365,338,266,209,298,334,542,386,426,425,359,378,462,388,413,383,290,239,325,282,273,257,218,145,143,160,149,134,154,13,120,99,168,174,146,136,117,100,84,147,150,143,134,115,101,119,180,153,137,160,149,108,112,149,167,148,174,282,228,163,193,209,192,192,162,168,155,186,200]],"line":{"color":"black","width":1},"font":{"color":"black","family":"Arial","size":10},"fill":{"color":["rgba(228, 222, 249, 0.65)","rgb(235, 193, 238)","rgba(228, 222, 249, 0.65)"]},"align":["center","center"]}}],
               {"margin":{"l":50,"b":60,"r":50,"t":60},"title":"Bitcoin mining stats for 180 days","width":1200}, {showLink: false});

 </script>



